=== debian/watch ===
version=4
# TODO: CTF v1.06 is hard-coded here, but I don't see a way around that
opts="repack,compression=gz,uversionmangle=s/_/./g,dversionmangle=s/[~+]dfsg[0-9]*//g;s/\+ctf.*//,oversionmangle=s/$/+ctf1.06~dfsg/" \
 https://github.com/yquake2/yquake2/releases .*/QUAKE2_(.*)\.tar\.gz
opts="uversionmangle=s/_/./g,dversionmangle=s/[~+]dfsg[0-9]*//g;s/.*\+ctf//,component=ctf,oversionmangle=s/$/+ctf1.06~dfsg/" \
 https://github.com/yquake2/ctf/releases .*/CTF_(.*)\.tar\.gz
