## yquake2 7.43+ctf1.07~dfsg

=== debian/changelog ===
yquake2 (7.43+ctf1.07~dfsg-1) unstable; urgency=medium

  [ Fabian Greffrath ]
  * Remove myself from Uploaders.

  [ Simon McVittie ]
  * New upstream release
  * Standards-Version: 4.5.0 (no changes required)
  * d/changelog: Trim trailing whitespace
  * d/upstream/metadata: Add
  * d/rules: Remove build options that no longer do anything
  * Redo patches to be (hopefully) upstreamable

 -- Simon McVittie <smcv@debian.org>  Fri, 28 Feb 2020 09:01:17 +0000
