=== debian/rules ===
--- 
+++ 
@@ -43,11 +43,9 @@
 
 override_dh_auto_build:
 	dh_auto_build -- \
-		DLOPEN_LIBGL=no \
-		DLOPEN_OPENAL=no \
 		VERBOSE=1 \
+		WITH_RPATH=no \
 		WITH_SYSTEMWIDE=yes \
-		WITH_X11GAMMA=yes \
 		YQ2_ARCH=$(DEB_HOST_ARCH_CPU) \
 		YQ2_OSTYPE=$(YQ2_OSTYPE) \
 		${NULL}
