=== debian/changelog ===
yquake2 (7.45+ctf1.07~dfsg-1) unstable; urgency=medium

  * New upstream release
  * Refresh patch series
    - Drop many patches, applied upstream
  * d/rules: Don't explicitly use --as-needed linker option.
    It's the default with bullseye toolchains.
  * d/p/signalhandler-Fix-a-typo.patch:
    Add patch to fix a typo detected by Lintian
  * d/patches: Move ctf patches into a topic subdirectory

 -- Simon McVittie <smcv@debian.org>  Sat, 31 Oct 2020 12:06:32 +0000
