=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,11 @@
 export LC_ALL=C.UTF-8
 export TZ=UTC
 
-DEB_LDFLAGS_MAINT_APPEND  += -Wl,--as-needed -Wl,-z,defs
-export DEB_CPPFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND
+DEB_LDFLAGS_MAINT_APPEND  += -Wl,-z,defs
+export DEB_LDFLAGS_MAINT_APPEND
+DPKG_EXPORT_BUILDFLAGS = yes
+include /usr/share/dpkg/default.mk
+export CFLAGS += $(CPPFLAGS)
 
 %:
 	dh $@
@@ -50,6 +53,7 @@
 		YQ2_OSTYPE=$(YQ2_OSTYPE) \
 		${NULL}
 	dh_auto_build --sourcedirectory=ctf -- \
+		OSTYPE=$(YQ2_OSTYPE) \
 		VERBOSE=1
 
 override_dh_install:
